CGAL 6.2 - 2D Arrangements: CGAL::Arr_rational_function_traits_2< AlgebraicKernel_d_1 >::Construct_x_monotone_curve_2 Class Reference

CGAL 6.2 - 2D Arrangements

Loading...
Searching...
No Matches
List of all members
CGAL::Arr_rational_function_traits_2< AlgebraicKernel_d_1 >::Construct_x_monotone_curve_2 Class Reference

`#include <CGAL/Arr_rational_function_traits_2.h>`

## Definition

template<typename AlgebraicKernel_d_1>
class CGAL::Arr_rational_function_traits_2< AlgebraicKernel_d_1 >::Construct_x_monotone_curve_2

Functor to construct a `X_monotone_curve_2`.

To enable caching the class is not default constructible and must be obtained via the function `construct_x_monotone_curve_2_object()`, which is a member of the traits.

Is model of
  `Assignable`
  `CopyConstructible`
  `AdaptableBinaryFunction`
  `AdaptableUnaryFunction`

## Types
typedef AlgebraicKernel_d_1::Polynomial_1 | Polynomial_1
typedef AlgebraicKernel_d_1::Algebraic_real_1 | Algebraic_real_1
typedef Arr_rational_function_traits_2< AlgebraicKernel_d_1 >::X_monotone_curve_2 | result_type
typedef Polynomial_1 | argument_type
typedef Polynomial_1 | first_argument_type
typedef Polynomial_1 | second_argument_type

## Operations
X_monotone_curve_2 | operator() (Polynomial_1 P) const
| constructs an \(x\)-monotone curve supported by the polynomial function \(y = P(x)\).
X_monotone_curve_2 | operator() (Polynomial_1 P, const Algebraic_real_1 &x, bool right) const
| constructs an \(x\)-monotone curve supported by the polynomial function \(y = P(x)\).
X_monotone_curve_2 | operator() (Polynomial_1 P, const Algebraic_real_1 &lower, const Algebraic_real_1 &upper) const
| constructs an \(x\)-monotone curve supported by the polynomial function \(y = P(x)\).
X_monotone_curve_2 | operator() (Polynomial_1 P, Polynomial_1 Q) const
| constructs an \(x\)-monotone curve supported by the rational function \(y = P(x)/Q(x)\).
X_monotone_curve_2 | operator() (Polynomial_1 P, Polynomial_1 Q, const Algebraic_real_1 &x, bool right) const
| constructs an \(x\)-monotone curve supported by the rational function \(y = P(x)/Q(x)\).
X_monotone_curve_2 | operator() (Polynomial_1 P, Polynomial_1 Q, const Algebraic_real_1 &lower, const Algebraic_real_1 &upper) const
| constructs an \(x\)-monotone curve supported by the rational function \(y = P(x)/Q(x)\).
template<typename InputIterator >
X_monotone_curve_2 | operator() (InputIterator begin, InputIterator end) const
| constructs an \(x\)-monotone curve supported by the polynomial function \(y = P(x)\), where the coefficients of \(P\) are given in the range `[begin,end)`.
template<typename InputIterator >
X_monotone_curve_2 | operator() (InputIterator begin, InputIterator end, const Algebraic_real_1 &x, bool right) const
| constructs an \(x\)-monotone curve supported by the polynomial function \(y = P(x)\), where the coefficients of \(P\) are given in the range `[begin,end)`.
template<typename InputIterator >
X_monotone_curve_2 | operator() (InputIterator begin, InputIterator end const Algebraic_real_1 &lower, const Algebraic_real_1 &upper) const
| constructs an \(x\)-monotone curve supported by the polynomial function \(y = P(x)\), where the coefficients of \(P\) are given in the range `[begin,end)`.
template<typename InputIterator >
X_monotone_curve_2 | operator() (InputIterator begin_numer, InputIterator end_numer, InputIterator begin_denom, InputIterator end_denom) const
| constructs an \(x\)-monotone curve supported by the rational function \(y = P(x)/Q(x)\), where the coefficients of \(P\) and \(Q\) are given in the ranges `[begin_numer,end_numer)` and `[begin_denom,end_denom)`, respectively.
template<typename InputIterator >
X_monotone_curve_2 | operator() (InputIterator begin_numer, InputIterator end_numer, InputIterator begin_denom, InputIterator end_denom, const Algebraic_real_1 &x, bool right) const
| constructs an \(x\)-monotone curve supported by the rational function \(y = P(x)/Q(x)\), where the coefficients of \(P\) and \(Q\) are given in the ranges `[begin_numer,end_numer)` and `[begin_denom,end_denom)`, respectively.
template<typename InputIterator >
X_monotone_curve_2 | operator() (InputIterator begin_numer, InputIterator end_numer, InputIterator begin_denom, InputIterator end_denom, const Algebraic_real_1 &lower, const Algebraic_real_1 &upper) const
| constructs an \(x\)-monotone curve supported by the rational function \(y = P(x)/Q(x)\), where the coefficients of \(P\) and \(Q\) are given in the ranges `[begin_numer,end_numer)` and `[begin_denom,end_denom)`, respectively.

## Member Function Documentation

## ◆ operator()() [1/10]

template<typename AlgebraicKernel_d_1 >
template<typename InputIterator >

X_monotone_curve_2 CGAL::Arr_rational_function_traits_2< AlgebraicKernel_d_1 >::Construct_x_monotone_curve_2::operator() | ( | InputIterator | begin,
|  | InputIterator end const Algebraic_real_1 & | lower,
|  | const Algebraic_real_1 & | upper
| ) |  | const

constructs an \(x\)-monotone curve supported by the polynomial function \(y = P(x)\), where the coefficients of \(P\) are given in the range `[begin,end)`.

The function is defined over the interval \([lower,upper]\).

## ◆ operator()() [2/10]

template<typename AlgebraicKernel_d_1 >
template<typename InputIterator >

X_monotone_curve_2 CGAL::Arr_rational_function_traits_2< AlgebraicKernel_d_1 >::Construct_x_monotone_curve_2::operator() | ( | InputIterator | begin,
|  | InputIterator | end,
|  | const Algebraic_real_1 & | x,
|  | bool | right
| ) |  | const

constructs an \(x\)-monotone curve supported by the polynomial function \(y = P(x)\), where the coefficients of \(P\) are given in the range `[begin,end)`.

The function is defined over the interval \([x,+\infty)\) if \(right\) is `true` and \((-\infty,x]\) otherwise.

## ◆ operator()() [3/10]

template<typename AlgebraicKernel_d_1 >
template<typename InputIterator >

X_monotone_curve_2 CGAL::Arr_rational_function_traits_2< AlgebraicKernel_d_1 >::Construct_x_monotone_curve_2::operator() | ( | InputIterator | begin_numer,
|  | InputIterator | end_numer,
|  | InputIterator | begin_denom,
|  | InputIterator | end_denom
| ) |  | const

constructs an \(x\)-monotone curve supported by the rational function \(y = P(x)/Q(x)\), where the coefficients of \(P\) and \(Q\) are given in the ranges `[begin_numer,end_numer)` and `[begin_denom,end_denom)`, respectively.

Precondition
  \(Q\) has no real roots.

## ◆ operator()() [4/10]

template<typename AlgebraicKernel_d_1 >
template<typename InputIterator >

X_monotone_curve_2 CGAL::Arr_rational_function_traits_2< AlgebraicKernel_d_1 >::Construct_x_monotone_curve_2::operator() | ( | InputIterator | begin_numer,
|  | InputIterator | end_numer,
|  | InputIterator | begin_denom,
|  | InputIterator | end_denom,
|  | const Algebraic_real_1 & | lower,
|  | const Algebraic_real_1 & | upper
| ) |  | const

constructs an \(x\)-monotone curve supported by the rational function \(y = P(x)/Q(x)\), where the coefficients of \(P\) and \(Q\) are given in the ranges `[begin_numer,end_numer)` and `[begin_denom,end_denom)`, respectively.

The function is defined over the interval \(I=[lower,upper]\).

Precondition
  \(Q\) has no real roots in the interior of \(I\).

## ◆ operator()() [5/10]

template<typename AlgebraicKernel_d_1 >
template<typename InputIterator >

X_monotone_curve_2 CGAL::Arr_rational_function_traits_2< AlgebraicKernel_d_1 >::Construct_x_monotone_curve_2::operator() | ( | InputIterator | begin_numer,
|  | InputIterator | end_numer,
|  | InputIterator | begin_denom,
|  | InputIterator | end_denom,
|  | const Algebraic_real_1 & | x,
|  | bool | right
| ) |  | const

constructs an \(x\)-monotone curve supported by the rational function \(y = P(x)/Q(x)\), where the coefficients of \(P\) and \(Q\) are given in the ranges `[begin_numer,end_numer)` and `[begin_denom,end_denom)`, respectively.

The function is defined over the interval \(I=[x,+\infty)\) if \(right\) is `true` and \(I=(-\infty,x]\) otherwise.

Precondition
  \(Q\) has no real roots in the interior of \(I\).

## ◆ operator()() [6/10]

template<typename AlgebraicKernel_d_1 >

X_monotone_curve_2 CGAL::Arr_rational_function_traits_2< AlgebraicKernel_d_1 >::Construct_x_monotone_curve_2::operator() | ( | Polynomial_1 | P,
|  | const Algebraic_real_1 & | lower,
|  | const Algebraic_real_1 & | upper
| ) |  | const

constructs an \(x\)-monotone curve supported by the polynomial function \(y = P(x)\).

The function is defined over the interval \([lower,upper]\).

## ◆ operator()() [7/10]

template<typename AlgebraicKernel_d_1 >

X_monotone_curve_2 CGAL::Arr_rational_function_traits_2< AlgebraicKernel_d_1 >::Construct_x_monotone_curve_2::operator() | ( | Polynomial_1 | P,
|  | const Algebraic_real_1 & | x,
|  | bool | right
| ) |  | const

constructs an \(x\)-monotone curve supported by the polynomial function \(y = P(x)\).

The function is defined over the interval \([x,+\infty)\) if \(right\) is `true` and \((-\infty,x]\) otherwise.

## ◆ operator()() [8/10]

template<typename AlgebraicKernel_d_1 >

X_monotone_curve_2 CGAL::Arr_rational_function_traits_2< AlgebraicKernel_d_1 >::Construct_x_monotone_curve_2::operator() | ( | Polynomial_1 | P,
|  | Polynomial_1 | Q
| ) |  | const

constructs an \(x\)-monotone curve supported by the rational function \(y = P(x)/Q(x)\).

Precondition
  \(Q\) has no real roots.

## ◆ operator()() [9/10]

template<typename AlgebraicKernel_d_1 >

X_monotone_curve_2 CGAL::Arr_rational_function_traits_2< AlgebraicKernel_d_1 >::Construct_x_monotone_curve_2::operator() | ( | Polynomial_1 | P,
|  | Polynomial_1 | Q,
|  | const Algebraic_real_1 & | lower,
|  | const Algebraic_real_1 & | upper
| ) |  | const

constructs an \(x\)-monotone curve supported by the rational function \(y = P(x)/Q(x)\).

The function is defined over the interval \(I=[lower,upper]\).

Precondition
  \(Q\) has no real roots in the interior of \(I\).

## ◆ operator()() [10/10]

template<typename AlgebraicKernel_d_1 >

X_monotone_curve_2 CGAL::Arr_rational_function_traits_2< AlgebraicKernel_d_1 >::Construct_x_monotone_curve_2::operator() | ( | Polynomial_1 | P,
|  | Polynomial_1 | Q,
|  | const Algebraic_real_1 & | x,
|  | bool | right
| ) |  | const

constructs an \(x\)-monotone curve supported by the rational function \(y = P(x)/Q(x)\).

The function is defined over the interval \(I=[x,+\infty)\) if \(right\) is `true` and \(I=(-\infty,x]\) otherwise.

Precondition
  \(Q\) has no real roots in the interior of \(I\).